"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var index_1 = require('../../index');
var moment = require('moment');
var template = require('./datepicker-input.html');
/**
 * Optional component which provides an example of basic usability case for the datepicker component
 */
var DatePickerInput = (function () {
    function DatePickerInput() {
        this.emitDate = new core_1.EventEmitter();
        // selected dates
        this.dates = 'Choose a date range';
    }
    DatePickerInput.prototype.ngOnInit = function () {
        if (this.beginDate && this.endDate) {
            var start = moment(this.beginDate);
            var end = moment(this.endDate);
            if (start.isValid() && end.isValid()) {
                this.dates = start.format('MMM DD, YYYY') + ' - ' + end.format('MMM DD, YYYY');
            }
        }
    };
    DatePickerInput.prototype.show = function (event) {
        this.dp.show();
        event.stopPropagation();
    };
    DatePickerInput.prototype.dateChange = function (event) {
        var start = moment(event.beginDate);
        var end = moment(event.endDate);
        this.dates = start.format('MMM DD, YYYY') + ' - ' + end.format('MMM DD, YYYY');
        this.emitDate.emit(event);
    };
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Number)
    ], DatePickerInput.prototype, "month", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Number)
    ], DatePickerInput.prototype, "year", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Number)
    ], DatePickerInput.prototype, "monthSpan", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Number)
    ], DatePickerInput.prototype, "maxRange", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Object)
    ], DatePickerInput.prototype, "beginRange", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Object)
    ], DatePickerInput.prototype, "endRange", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Object)
    ], DatePickerInput.prototype, "beginDate", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Object)
    ], DatePickerInput.prototype, "endDate", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], DatePickerInput.prototype, "alignCal", void 0);
    __decorate([
        core_1.ViewChild(index_1.DatePicker), 
        __metadata('design:type', index_1.DatePicker)
    ], DatePickerInput.prototype, "dp", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', Object)
    ], DatePickerInput.prototype, "emitDate", void 0);
    DatePickerInput = __decorate([
        core_1.Component({
            selector: 'datepicker-input',
            styles: ["span { cursor: pointer; font-family: 'Open Sans', 'Helvetica Neue', 'Helvetica'; border: 1px solid #ccc; \n        padding: 4px 10px; display: inline-block; text-align: center; background-color: white; }"],
            template: template
        }), 
        __metadata('design:paramtypes', [])
    ], DatePickerInput);
    return DatePickerInput;
}());
exports.DatePickerInput = DatePickerInput;
;
//# sourceMappingURL=datepicker-input.js.map