"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var moment = require('moment');
/**
 * These pagination controls are designed to work with a pagination list wrapper, which is taken as an input along with
 * the desired page size.
 *
 * @input settings: this is the pagination wrapper.
 * @input pageSize: this is the desired number of results per page.
 *
 * @output emitPaginate: this event is intended to be heard by a handler which queries the wrapper for the desired
 * range of results.
 *
 * ### Simple Example
 *
 * ```
 * <pagination [settings]="paginationSettings" (emitPaginate)="onPaginate($event)"></pagination>
 * ```
 *
 */
var DatePicker = (function () {
    function DatePicker() {
        this.emitDate = new core_1.EventEmitter();
        this.monthText = ['JAN', 'FEB', 'MAR', 'APR',
            'MAY', 'JUN', 'JUL', 'AUG', 'SEP', 'OCT', 'NOV', 'DEC'];
        this.dayText = ['S', 'M', 'T', 'W', 'T', 'F', 'S'];
        // visibility binding
        this.hideComponent = true;
        this.paginationLeft = '';
        this.paginationRight = '';
        this.alignClass = '';
        // internal members
        this._year = moment().year();
        this._monthSpan = 1;
        this._maxRange = 1;
    }
    Object.defineProperty(DatePicker.prototype, "month", {
        // all integer input will be non-zero based to be user-friendly
        set: function (value) {
            if (!value) {
                return;
            }
            else if (value < 1 || value > 12) {
                throw RangeError('Invalid month: ' + value);
            }
            else {
                this._baseMonth = value - 1;
            }
        },
        enumerable: true,
        configurable: true
    });
    ;
    Object.defineProperty(DatePicker.prototype, "year", {
        set: function (value) {
            if (!value) {
                return;
            }
            else if (value < 1900 || value > 2100) {
                throw RangeError('Invalid year: ' + value);
            }
            else {
                this._year = value;
            }
        },
        enumerable: true,
        configurable: true
    });
    ;
    Object.defineProperty(DatePicker.prototype, "monthSpan", {
        set: function (value) {
            if (value > 3 || value < 1) {
                throw RangeError('Invalid monthSpan: ' + value);
            }
            else {
                this._monthSpan = value;
            }
        },
        enumerable: true,
        configurable: true
    });
    ;
    Object.defineProperty(DatePicker.prototype, "maxRange", {
        set: function (value) {
            if (value < 1) {
                throw RangeError('Invalid maxRange: ' + value);
            }
            else {
                this._maxRange = value;
            }
        },
        enumerable: true,
        configurable: true
    });
    ;
    Object.defineProperty(DatePicker.prototype, "beginRange", {
        // strict range limits
        set: function (value) {
            if (value) {
                this._beginRange = moment(value);
            }
        },
        enumerable: true,
        configurable: true
    });
    ;
    Object.defineProperty(DatePicker.prototype, "endRange", {
        set: function (value) {
            if (value) {
                this._endRange = moment(value);
            }
        },
        enumerable: true,
        configurable: true
    });
    ;
    Object.defineProperty(DatePicker.prototype, "beginDate", {
        // preselected dates
        set: function (value) {
            if (value) {
                this._beginDate = moment(value);
            }
        },
        enumerable: true,
        configurable: true
    });
    ;
    Object.defineProperty(DatePicker.prototype, "endDate", {
        set: function (value) {
            if (value) {
                this._endDate = moment(value);
            }
        },
        enumerable: true,
        configurable: true
    });
    ;
    Object.defineProperty(DatePicker.prototype, "alignCal", {
        // display alignment
        set: function (value) {
            if (value === 'right' || value === 'left' || value === 'top' || value === 'bottom') {
                this.alignClass = value;
            }
            else if (value) {
                throw Error('Invalid alignment: ' + value);
            }
        },
        enumerable: true,
        configurable: true
    });
    ;
    DatePicker.prototype.ngOnInit = function () {
        this.now = moment();
        this._baseMonth = moment().month();
        this.updateViewModel(); // initiate first render
    };
    DatePicker.prototype.show = function () {
        this.hideComponent = false;
    };
    DatePicker.prototype.close = function () {
        this.hideComponent = true;
    };
    /**
     * Method called by template to submit date selection
     * Emits event through the output (only function to do so)
     */
    DatePicker.prototype.emit = function () {
        // validate chosen date then emit event
        if (this.sanityCheck(false)) {
            this.emitDate.emit({ beginDate: +(this._beginDate), endDate: +(this._endDate) });
            this.close();
        }
    };
    /**
     * Method called by template to display new set of months in the viewModel
     * Calls updateViewModel without mutating selected dates
     */
    DatePicker.prototype.nextMonth = function (interval) {
        if (interval === void 0) { interval = 0; }
        if (interval === 0) {
            this._year = this.now.year();
            this.updateViewModel(this.now.month());
        }
        else {
            this.updateViewModel(this._baseMonth + interval);
        }
    };
    /**
     * Method to register date selection called by the template. Updates viewModel.
     * @param {number} year - Chosen year
     * @param {number} month - Chosen month
     * @param {number} day - Chosen day
     */
    DatePicker.prototype.chooseDate = function (year, month, day) {
        // ignore blank dates
        if (!day) {
            return;
        }
        // CASE: Single day picker
        if (this._maxRange === 1) {
            this._beginDate = this._endDate = moment([year, month, day]);
        }
        else if (!this._beginDate || this._beginDate && this._endDate) {
            this._beginDate = moment([year, month, day]);
            this._endDate = undefined;
        }
        else {
            this._endDate = moment([year, month, day]);
        }
        // update viewModel, regardless of sanity check result
        this.sanityCheck();
        this.updateViewModel();
    };
    /**
     * Internal method to trigger an update of the calendar with latest data
     * Side-effect: this.viewModel gets updated with new calendar data
     * @param {number} [newMonth=currentMonth] New base month
     */
    DatePicker.prototype.updateViewModel = function (newMonth) {
        if (newMonth === void 0) { newMonth = this._baseMonth; }
        /** Const with offset to first and last month to be drawn */
        var begin = (this._monthSpan === 3) ? -1 : 0;
        var end = (this._monthSpan === 1) ? 1 : 2;
        /** Const with earliest and latest dates that will be rendered */
        var earliestDate = moment(moment([this._year, newMonth + begin + 1, 1])['_d']);
        var latestDate = moment(moment([this._year, newMonth + end - 1, -1])['_d']);
        /** verify all dates will fall within the restrictive range */
        if (this._beginRange && this._beginRange.isAfter(earliestDate)) {
            this.paginationLeft = 'disabled';
        }
        else if (this._endRange && this._endRange.isBefore(latestDate)) {
            this.paginationRight = 'disabled';
        }
        else {
            /** Reset pagination controls */
            this.paginationLeft = '';
            this.paginationRight = '';
        }
        /** Reset viewModel and update month properties */
        this.viewModel = [];
        this._baseMonth = newMonth;
        for (var i = begin; i < end; i++) {
            /** Get year and month (with overflow handling 2016/13 -> 2017/1) */
            var renderDate = moment(moment([this._year, this._baseMonth + i, 1])['_d']);
            var year = renderDate.year();
            var month = renderDate.month();
            this.viewModel.push({
                calendar: '',
                days: this.generateCalendar(year, month),
                month: month,
                monthText: this.monthText[month],
                year: year
            });
        }
    };
    /**
     * Method that generates calendar HTML
     * @param {number} year Calendar display year.
     * @param {number} month Calendar display month. (zero-based)
     * @return {string[][]}
     */
    DatePicker.prototype.generateCalendar = function (year, month) {
        var _this = this;
        var calendar = [];
        var firstDay = (new Date(year, month)).getDay(); // first day of the month offset
        var monthLength = (new Date(year, month + 1, 0)).getDate(); // days in the month
        var generateDay = function (day) {
            var newDay = { day: undefined, style: 'normal' };
            var styles = [];
            // empty day object paddings
            if (day === 0) {
                newDay.style = 'disabled';
                return newDay;
            }
            // copy integer day
            newDay.day = day;
            styles.push('normal');
            /** States to help apply appropriate styles */
            var sBegin = !(!_this._beginDate || _this._endDate);
            var sComplete = !(!_this._beginDate || !_this._endDate);
            var TS = moment([year, month, day]);
            var max = (sBegin) ? moment(_this._beginDate).add(_this._maxRange, 'days') : 0;
            /** Apply today class regardless of state */
            if (TS.isSame(_this.now, 'day')) {
                styles.push('today');
            }
            /** Apply start & enddate styles */
            if (_this._beginDate && TS.isSame(_this._beginDate, 'day')) {
                styles.push('startdate');
            }
            if (sComplete && TS.isSame(_this._endDate, 'day')) {
                styles.push('enddate');
            }
            /** Apply highlight to selected date range */
            if (sComplete && TS.isSameOrAfter(_this._beginDate, 'day')
                && TS.isSameOrBefore(_this._endDate, 'day')) {
                styles.push('between');
            }
            // available tobe selected dates
            if (sBegin && TS.isAfter(_this._beginDate, 'day')
                && TS.isSameOrBefore(max, 'day')
                && TS.isSameOrBefore(_this._endRange, 'day')) {
                styles.push('availble-range');
            }
            // disable out of range dates    
            if (_this._beginRange && TS.isBefore(_this._beginRange, 'day')) {
                styles.push('disabled');
            }
            else if (_this._endRange && TS.isAfter(_this._endRange, 'day')) {
                styles.push('disabled');
            }
            // flatten styles array to a single string
            newDay.style = styles.join(' ');
            return newDay;
        };
        // loop variables
        var totalDays = 1;
        var rowDays = 0;
        var row = [];
        // loop until all days have been generated
        while (totalDays <= monthLength) {
            var day = void 0;
            // insert empty days until we reach the right day of week
            if (firstDay !== 0) {
                day = generateDay.call(this, 0);
                firstDay--;
            }
            else {
                // if row is full create a new row
                if (rowDays === 7) {
                    calendar.push(row);
                    rowDays = 0;
                    row = [];
                }
                day = generateDay.call(this, totalDays);
                totalDays++;
            }
            row.push(day);
            rowDays++;
        }
        // do a final push for the last row and return
        calendar.push(row);
        return calendar;
    };
    /**
     * Utility method to sanity-check given dates
     * SIDE-EFFECT: Will mutate properties _beginDate and/or _endDate to appropriate
     *   values if they are found to be insane and sanitize flag is on.
     * @param {boolean} [sanitize=true] Fix invalid values (induces side-effect)
     * @return {boolean} Go for launch?
     */
    DatePicker.prototype.sanityCheck = function (sanitize) {
        var _this = this;
        if (sanitize === void 0) { sanitize = true; }
        // function to check if date is within accepted range
        var isInRange = function (d) {
            if (_this._beginRange && d.isBefore(_this._beginRange, 'day')) {
                return false;
            }
            if (_this._endRange && d.isAfter(_this._endRange, 'day')) {
                return false;
            }
            return true;
        };
        // function to return check as fail and sanitize if requested
        var doSanitize = function (beginDate, endDate) {
            if (sanitize) {
                _this._beginDate = beginDate;
                _this._endDate = endDate;
            }
            return false;
        };
        // reject if _startDate goes before beginRange
        if (!isInRange(this._beginDate)) {
            return doSanitize(undefined, undefined);
        }
        // reject if either _beginDate or _endDate is missing
        if (!this._beginDate || !this._endDate) {
            return false;
        }
        // reject if _endDate goes beyond endRange
        if (!isInRange(this._endDate)) {
            return doSanitize(this._beginDate, undefined);
        }
        // reject if _endDate comes before _beginDate
        if (this._endDate.isBefore(this._beginDate)) {
            return doSanitize(this._endDate, undefined);
        }
        // reject if _endDate goes beyond max range length limit
        if (this._endDate.isAfter(moment(this._beginDate).add(this._maxRange, 'days'))) {
            return doSanitize(this._endDate, undefined);
        }
        // otherwise all is good
        return true;
    };
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Number), 
        __metadata('design:paramtypes', [Number])
    ], DatePicker.prototype, "month", null);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Number), 
        __metadata('design:paramtypes', [Number])
    ], DatePicker.prototype, "year", null);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Number), 
        __metadata('design:paramtypes', [Number])
    ], DatePicker.prototype, "monthSpan", null);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Number), 
        __metadata('design:paramtypes', [Number])
    ], DatePicker.prototype, "maxRange", null);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Object), 
        __metadata('design:paramtypes', [Object])
    ], DatePicker.prototype, "beginRange", null);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Object), 
        __metadata('design:paramtypes', [Object])
    ], DatePicker.prototype, "endRange", null);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Object), 
        __metadata('design:paramtypes', [Object])
    ], DatePicker.prototype, "beginDate", null);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Object), 
        __metadata('design:paramtypes', [Object])
    ], DatePicker.prototype, "endDate", null);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String), 
        __metadata('design:paramtypes', [String])
    ], DatePicker.prototype, "alignCal", null);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', Object)
    ], DatePicker.prototype, "emitDate", void 0);
    DatePicker = __decorate([
        core_1.Component({
            selector: 'datepicker',
            styles: [require('!!css-loader!less-loader!./datepicker.less').toString()],
            template: require('./datepicker.html')
        }), 
        __metadata('design:paramtypes', [])
    ], DatePicker);
    return DatePicker;
}());
exports.DatePicker = DatePicker;
//# sourceMappingURL=datepicker.js.map