"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var rxjs_1 = require('rxjs');
var template = require('./filtering.html');
var styles = require('!!css-loader!less-loader!./filtering.less');
var Filtering = (function () {
    function Filtering() {
        this.emitFilter = new core_1.EventEmitter();
        this.allField = { field: '', label: 'All' };
        this.filteredBy = this.allField;
        this.filterTermStream = new rxjs_1.Subject();
    }
    Filtering.prototype.filter = function (term) { this.filterTermStream.next(term); };
    Filtering.prototype.filterBy = function (field, value) {
        this.filteredBy = field;
        if (value) {
            this.emitFilter.emit({ filterBy: this.filteredBy.field, filterText: value });
        }
    };
    Filtering.prototype.ngOnInit = function () {
        var _this = this;
        this.filterTermStream
            .debounceTime(400)
            .distinctUntilChanged()
            .subscribe(function (term) {
            _this.emitFilter.emit({ filterBy: _this.filteredBy.field, filterText: term });
        });
    };
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Array)
    ], Filtering.prototype, "filterFields", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', Object)
    ], Filtering.prototype, "emitFilter", void 0);
    Filtering = __decorate([
        core_1.Component({
            selector: 'filtering',
            styles: [styles.toString()],
            template: template
        }), 
        __metadata('design:paramtypes', [])
    ], Filtering);
    return Filtering;
}());
exports.Filtering = Filtering;
var Filtering;
(function (Filtering) {
    'use strict';
})(Filtering = exports.Filtering || (exports.Filtering = {}));
//# sourceMappingURL=filtering.js.map