"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var ModalBase = (function () {
    function ModalBase() {
        this.modalClass = '';
        this.emitClose = new core_1.EventEmitter();
        this.isOpened = false;
    }
    ModalBase.prototype.ngOnInit = function () {
        this.createBackDrop();
        this.combinedModalClass = this.modalClass ? 'modal-dialog ' + this.modalClass : 'modal-dialog';
    };
    ModalBase.prototype.open = function () {
        var _this = this;
        this.isOpened = true;
        document.body.appendChild(this.backdropElement);
        setTimeout(function () { return _this.modal.nativeElement.focus(); });
    };
    ModalBase.prototype.close = function () {
        this.isOpened = false;
        var backdropAttached = !!this.backdropElement.parentElement;
        if (backdropAttached) {
            document.body.removeChild(this.backdropElement);
        }
        this.emitClose.emit();
    };
    ModalBase.prototype.createBackDrop = function () {
        this.backdropElement = document.createElement('div');
        this.backdropElement.classList.add('fade', 'in', 'modal-backdrop');
    };
    __decorate([
        core_1.ViewChild('modal'), 
        __metadata('design:type', core_1.ElementRef)
    ], ModalBase.prototype, "modal", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], ModalBase.prototype, "modalClass", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', core_1.EventEmitter)
    ], ModalBase.prototype, "emitClose", void 0);
    ModalBase = __decorate([
        core_1.Component({
            selector: 'modal-base',
            styles: [require('!!css-loader!less-loader!./modal-base.less').toString()],
            template: require('./modal-base.html')
        }), 
        __metadata('design:paramtypes', [])
    ], ModalBase);
    return ModalBase;
}());
exports.ModalBase = ModalBase;
//# sourceMappingURL=modal-base.js.map