"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var notification_service_1 = require('./notification-service');
var styles = require('!!css-loader!less-loader!./notification.less');
var Notification = (function () {
    function Notification(notificationService) {
        this.notificationService = notificationService;
        this.iconCssPrefix = 'glyphicon';
        this.baseColor = 'empty';
        this.hide = false;
        this.icon = this.iconCssPrefix + " " + this.iconCssPrefix + "-alert";
        this.hideTime = 1000;
        this.fadeTime = 4000;
    }
    Notification.prototype.show = function (message, type) {
        var _this = this;
        this.notification = message;
        switch (type) {
            case 'success':
                this.fadeTimerHandle = setTimeout(function () { return _this.close(); }, this.fadeTime);
                this.setIconClass('ok');
                this.baseColor = 'success';
                break;
            case 'warning':
                this.setIconClass('alert');
                this.baseColor = 'warning';
                break;
            default:
                this.setIconClass('alert');
                this.baseColor = 'error';
                break;
        }
    };
    Notification.prototype.setIconClass = function (type) {
        this.icon = this.iconCssPrefix + " " + this.iconCssPrefix + "-" + type;
    };
    Notification.prototype.close = function () {
        var _this = this;
        this.hide = true;
        setTimeout(function () {
            _this.fadeTimerHandle = undefined;
            _this.notification = undefined;
            _this.baseColor = 'empty';
            _this.hide = false;
        }, this.hideTime);
    };
    Notification.prototype.resetTimer = function () {
        if (this.fadeTimerHandle) {
            clearTimeout(this.fadeTimerHandle);
        }
    };
    Notification.prototype.restartTimer = function () {
        var _this = this;
        if (this.fadeTimerHandle) {
            this.fadeTimerHandle = setTimeout(function () { return _this.close(); }, this.fadeTime);
        }
    };
    Notification.prototype.ngOnInit = function () {
        var _this = this;
        this.serviceSubscription = this.notificationService.observe$.subscribe(function (notification) {
            _this.show(notification.message, notification.type);
        });
    };
    Notification.prototype.ngOnDestroy = function () {
        this.serviceSubscription.unsubscribe();
        this.serviceSubscription = undefined;
    };
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], Notification.prototype, "iconCssPrefix", void 0);
    Notification = __decorate([
        core_1.Component({
            selector: 'notification',
            styles: [styles.toString()],
            template: "\n    <div class=\"notification-container ut-root-element\" [ngClass]=\"baseColor\" [class.show]=\"notification\" [class.hide]=\"hide\">\n        <div class=\"notification-content\" (mouseover)=\"resetTimer()\" (mouseout)=\"restartTimer()\">\n            <div aria-hidden=\"true\" class=\"close\" (click)=\"close()\">x</div>\n            <div><span class=\"ut-icon\" [ngClass]=\"icon\"></span><span class=\"main-text ut-main-text\">{{ notification }}</span></div>\n        </div>\n    </div>\n    "
        }), 
        __metadata('design:paramtypes', [notification_service_1.NotificationService])
    ], Notification);
    return Notification;
}());
exports.Notification = Notification;
//# sourceMappingURL=notification.js.map