"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var styles = require('!!css-loader!less-loader!./pagination.less');
var Pagination = (function () {
    function Pagination() {
        this.pageSize = 25;
        this.emitPaginate = new core_1.EventEmitter();
    }
    Pagination.prototype.forward = function () {
        if (this.settings.to === this.settings.filteredCount) {
            return;
        }
        var to = Math.min(this.settings.filteredCount, this.settings.to + this.pageSize);
        this.emitPaginate.emit({ from: this.settings.to, to: to });
    };
    Pagination.prototype.backward = function () {
        if (this.settings.from < 1) {
            return;
        }
        this.emitPaginate.emit({ from: this.settings.from - this.pageSize, to: this.settings.from });
    };
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], Pagination.prototype, "emptyMessage", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Object)
    ], Pagination.prototype, "settings", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Number)
    ], Pagination.prototype, "pageSize", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', Object)
    ], Pagination.prototype, "emitPaginate", void 0);
    Pagination = __decorate([
        core_1.Component({
            selector: 'pagination',
            styles: [styles.toString()],
            template: "\n    <div class=\"alm-pagination\">\n        <span class=\"alm-pagination-text alm-pagination-text-empty\" *ngIf=\"emptyMessage && !settings?.filteredCount\">\n            {{ emptyMessage }}\n        </span>\n        <span class=\"alm-pagination-text\" *ngIf=\"settings?.filteredCount\">\n        {{ settings?.from + 1 }} - {{ settings?.to }} of {{ settings?.filteredCount }}\n        </span>\n        <span class=\"alm-pagination-text\" *ngIf=\"settings?.filteredCount !== settings?.count\">\n            (filtered from a total of {{ settings.count }})</span>\n        <div class=\"btn-group\" role=\"group\">\n             <button class=\"alm-pagination-symbol btn btn-default btn-sm backward\"\n                    (click)=\"backward()\"\n                    [disabled]=\"settings?.from < 1\"></button>\n            <button class=\"alm-pagination-symbol btn btn-default btn-sm forward\"\n                    (click)=\"forward()\"\n                    [disabled]=\"settings?.to === settings?.filteredCount\"></button>\n        </div>\n    </div>\n    "
        }), 
        __metadata('design:paramtypes', [])
    ], Pagination);
    return Pagination;
}());
exports.Pagination = Pagination;
var Pagination;
(function (Pagination) {
    'use strict';
})(Pagination = exports.Pagination || (exports.Pagination = {}));
//# sourceMappingURL=pagination.js.map