"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var rxjs_1 = require('rxjs');
/**
 * This service is used alongside the Progress component provided in this library to indicate that an SPA event is in
 * progress (e.g. an ajax call has been sent and it is in-flight). If you are using the ClientObserver from this library
 * to spy on your calls, its public `clientEvents` stream can be used as the input to this service's `notify` method
 * to easily display your calls' progress in the UI.
 *
 * ### Simple Example
 *
 * To use it on your SPA:
 *
 * Add it to your app module so it can be injected on your components
 * ```
 * @NgModule({
 *   bootstrap:     [ AppComponent ],
 *   declarations:  [ AppComponent ],
 *   imports:       [ Ng2UEUtilsModule ],
 *   providers:     [ ProgressService, ClientObserver ]
 * })
 * ```
 *
 * And in your component
 * ```
 * import { ProgressService, IClientEvent, ClientEvent, ClientMethod } from 'ng2-ue-utils';
 *
 * @Component({
 *     selector: 'my-content',
 *     template: template
 * })
 * class MyContent {
 *
 *     constructor(private progressService: ProgressService, private spy: ClientObserver){}
 *
 *     // Use with ClientObserver
 *     private subscribeToServerCallsEvents () {
 *       this.spy.clientEvents
 *          .filter(status => status.event !== 'next')
 *          .subscribe((event: IClientEvent) => {
 *               this.progressService.notify(event);
 *           });
 *     }
 *
 *     // Use without ClientObserver
 *     private updateProgressBarManually(event: string, method: string, stackCount: number){
 *         const event: IClientEvent = {
 *             event: event as ClientEvent,
 *             method: method as ClientMethod,
 *             stackCount: number // This should be a zero if no pending calls, so progress can be shown as finished.
 *         }
 *         this.progressService.notify(event);
 *     }
 * }
 * ```
 */
var ProgressService = (function () {
    function ProgressService() {
        this.observer = new rxjs_1.BehaviorSubject(undefined);
        this.observe$ = this.observer.asObservable();
    }
    ProgressService.prototype.notify = function (event) {
        this.observer.next(event);
    };
    ProgressService = __decorate([
        core_1.Injectable(), 
        __metadata('design:paramtypes', [])
    ], ProgressService);
    return ProgressService;
}());
exports.ProgressService = ProgressService;
//# sourceMappingURL=progress-service.js.map