"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var progress_service_1 = require('./progress-service');
var styles = require('!!css-loader!less-loader!./progress.less');
var Progress = (function () {
    function Progress(progressService, cdr) {
        this.progressService = progressService;
        this.cdr = cdr;
        this.baseColor = 'empty';
        this.progressColor = 'empty';
        this.progress = 0;
        this.status = 'init';
    }
    Progress.prototype.onEmit = function (status) {
        if (status.event === 'start' && (this.restartOnAjax || this.status === 'init')) {
            this.start();
        }
        else {
            this.setStatus(status.event, status.method);
            if (!status.stackCount) {
                this.end();
            }
        }
    };
    Progress.prototype.setStatus = function (value, method) {
        switch (value) {
            case 'error':
                this.status = value;
                break;
            case 'warning':
                this.status = this.status !== value ? 'warning' : this.status;
                break;
            case 'complete':
                if (this.status !== 'error' && this.status !== 'warning' && method !== 'get') {
                    this.status = 'success';
                }
                break;
            default:
                break;
        }
    };
    Progress.prototype.start = function () {
        clearTimeout(this.initColorsTimeoutId);
        this.status = 'started';
        this.baseColor = 'on';
        this.progressColor = 'default';
        this.progress = 0;
        this.cdr.detectChanges();
        this.grow();
    };
    Progress.prototype.end = function () {
        var _this = this;
        this.progress = 100;
        clearInterval(this.intervalId);
        if (this.status) {
            this.progressColor = this.status;
            this.status = 'init';
        }
        this.initColorsTimeoutId = setTimeout(function () {
            _this.baseColor = 'empty';
            _this.progressColor = 'empty';
        }, 500);
    };
    Progress.prototype.grow = function () {
        var _this = this;
        clearInterval(this.intervalId);
        this.intervalId = setInterval(function () {
            var remaining = 100 - _this.progress;
            _this.progress = _this.progress + (0.15 * Math.pow(1 - Math.sqrt(remaining), 2));
        }, 200);
    };
    Progress.prototype.ngOnInit = function () {
        var _this = this;
        this.subscription = this.progressService.observe$
            .filter(function (status) { return !!status; })
            .filter(function (status) { return status.event !== 'next'; })
            .subscribe(function (event) {
            _this.onEmit(event);
        });
    };
    Progress.prototype.ngOnDestroy = function () {
        clearInterval(this.intervalId);
        this.subscription.unsubscribe();
        this.subscription = undefined;
    };
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Boolean)
    ], Progress.prototype, "restartOnAjax", void 0);
    Progress = __decorate([
        core_1.Component({
            selector: 'progress-bar',
            styles: [styles.toString()],
            template: "\n    <div class=\"progress-container ut-root\" [ngClass]=\"baseColor\">\n        <div class=\"progress-reporter ut-reporter\" [ngClass]=\"progressColor\" [style.width.%]=\"progress\" [hidden]=\"!progress\"></div>\n    </div>\n    "
        }), 
        __metadata('design:paramtypes', [progress_service_1.ProgressService, core_1.ChangeDetectorRef])
    ], Progress);
    return Progress;
}());
exports.Progress = Progress;
//# sourceMappingURL=progress.js.map