"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var moment = require('moment');
/**
 * As of Angular RC2, date pipes are broken for some browsers at least for using timestamps to be formatted to strings.
 * This pipe is meant to be use to overcome that issue. It is using moment to do the formatting.
 * @param {number} timestamp - number representing a valid date, like 1467929380554
 * @param {string} format - a moment valid format string. Check out {@link http://momentjs.com/docs/#/parsing/string-format/|momentjs}
 *
 * ### Simple Example
 *
 * ```
 * <span>{{timestamp | dateMoment }}</span>
 * ```
 *
 * will result on something like
 * ```
 * <span>Sep 4 1986 8:30 PM</span>
 * ```
 *
 * ### Example for using a different format
 *
 * ```
 * <span>{{timestamp | dateMoment:'MM-DD-YYYY' }}</span>
 * ```
 *
 * will result in something like
 * ```
 * <span>02-08-2013</span>
 * ```
 *
 */
var DateMoment = (function () {
    function DateMoment() {
    }
    DateMoment.prototype.transform = function (timestamp, args) {
        if (!timestamp) {
            return 'unknown';
        }
        var date = moment(timestamp);
        if (date.isValid()) {
            return date.format(args || 'lll');
        }
        return 'Invalid date';
    };
    DateMoment = __decorate([
        core_1.Pipe({ name: 'dateMoment' }), 
        __metadata('design:paramtypes', [])
    ], DateMoment);
    return DateMoment;
}());
exports.DateMoment = DateMoment;
//# sourceMappingURL=date-moment.js.map