import { PipeTransform } from '@angular/core';
/**
 * This pipe leverages moment.js to format a valid timestamp into a relative time statement.
 * @param {number} timestamp - number representing a valid date, like 1467929380554
 *
 * ### Simple Example
 *
 * ```
 * <span>{{ timestamp | fromNow }}</span>
 * ```
 *
 * will result on something like
 * ```
 * <span>Ten minutes ago</span>
 * ```
 *
 */
export declare class FromNow implements PipeTransform {
    transform(timestamp: number): string;
}
