"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var moment = require('moment');
/**
 * This pipe leverages moment.js to format a valid timestamp into a relative time statement.
 * @param {number} timestamp - number representing a valid date, like 1467929380554
 *
 * ### Simple Example
 *
 * ```
 * <span>{{ timestamp | fromNow }}</span>
 * ```
 *
 * will result on something like
 * ```
 * <span>Ten minutes ago</span>
 * ```
 *
 */
var FromNow = (function () {
    function FromNow() {
    }
    FromNow.prototype.transform = function (timestamp) {
        if (!timestamp) {
            return 'unknown';
        }
        return moment(timestamp).fromNow();
    };
    FromNow = __decorate([
        core_1.Pipe({ name: 'fromNow' }), 
        __metadata('design:paramtypes', [])
    ], FromNow);
    return FromNow;
}());
exports.FromNow = FromNow;
//# sourceMappingURL=from-now.js.map