"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var Rx_1 = require('rxjs/Rx');
var ClientObserver = (function () {
    function ClientObserver() {
        var _this = this;
        this._emitter = new Rx_1.Subject();
        this._stackCount = 0;
        this.clientEvents = this._emitter.asObservable();
        this.countUp = function () { _this._stackCount++; };
        this.countDown = function () { _this._stackCount = Math.max(0, _this._stackCount - 1); };
        this.emitChange = function (event, method, path, error) {
            if (event === 'start') {
                _this.countUp();
            }
            if (event === 'error' || event === 'complete') {
                _this.countDown();
            }
            _this._emitter.next({
                error: error ? (error.message || error) : undefined,
                errorInfo: error,
                event: event,
                method: method,
                path: path,
                stackCount: _this._stackCount
            });
        };
        this.observeOn = function (method, obs, path) {
            _this.emitChange('start', method, path);
            return obs.do(function (next) {
                _this.emitChange('next', method, path);
            }, function (error) {
                _this.emitChange('error', method, path, error);
            }, function () {
                _this.emitChange('complete', method, path);
            });
        };
    }
    ClientObserver = __decorate([
        core_1.Injectable(), 
        __metadata('design:paramtypes', [])
    ], ClientObserver);
    return ClientObserver;
}());
exports.ClientObserver = ClientObserver;
//# sourceMappingURL=clientObserver.js.map