import { Observable } from 'rxjs/Rx';
import { RolePermissions } from 'rbac-abacus';
import { ClientObserver } from './clientObserver';
import { ApiRoutes } from '../router/api-routes';
import { Client } from './client';
import { ObservableClientBase } from './observable-client-base';
export declare abstract class ObservableClient extends ObservableClientBase {
    protected router: ApiRoutes;
    constructor(client: Client, router: ApiRoutes, spy?: ClientObserver);
    abstract getList<T>(...callParams: any[]): Observable<T[]>;
    private userInfo;
    private userRoles;
    updateEntity: <T, U>(identifier: string, entity: U) => Observable<T>;
    deleteEntity: <T>(identifier: string) => Observable<T>;
    createEntity: <T, U>(entity: U) => Observable<T>;
    getEntity: <T>(identifier: string) => Observable<T>;
    getListObject: <T>() => Observable<T>;
    permissions: () => Observable<RolePermissions>;
}
