"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var Rx_1 = require('rxjs/Rx');
var rbac_abacus_1 = require('rbac-abacus');
var observable_client_base_1 = require('./observable-client-base');
var ObservableClient = (function (_super) {
    __extends(ObservableClient, _super);
    function ObservableClient(client, router, spy) {
        var _this = this;
        _super.call(this, client, spy);
        this.router = router;
        this.userInfo = function () { return _this.get(_this.router.userInfo()); };
        this.userRoles = function () {
            var org = _this.router.orgName;
            return _this.userInfo()
                .flatMap(function (info) { return _this.get(_this.router.userRoles(info.email)); })
                .map(function (col) { return col.role.filter(function (r) { return r.organization === org; }); });
        };
        this.updateEntity = function (identifier, entity) {
            return _this.put(_this.router.entity(identifier), entity);
        };
        this.deleteEntity = function (identifier) {
            return _this.delete(_this.router.entity(identifier));
        };
        this.createEntity = function (entity) {
            return _this.post(_this.router.new(), entity);
        };
        this.getEntity = function (identifier) {
            return _this.get(_this.router.entity(identifier));
        };
        this.getListObject = function () {
            return _this.get(_this.router.list());
        };
        this.permissions = function () {
            return _this.userRoles()
                .flatMap(function (roles) {
                if (roles.length < 1) {
                    throw Error('User is not part of this organization.');
                }
                var obs = roles.map(function (r) { return _this.get(_this.router.orgRole(r.name)); });
                return Rx_1.Observable.combineLatest(obs);
            })
                .map(function (permArray) { return permArray.map(function (p) { return new rbac_abacus_1.RolePermissions(p); }); })
                .map(function (permArray) {
                return permArray.reduce(function (prev, perm) { return prev.merge(perm); }, new rbac_abacus_1.RolePermissions());
            });
        };
    }
    return ObservableClient;
}(observable_client_base_1.ObservableClientBase));
exports.ObservableClient = ObservableClient;
//# sourceMappingURL=observable-client.js.map