"use strict";
var splitParts = function (token) { return token ? token.split('.') : []; };
var ensureThreeParts = function (arr) { return ['', '', ''].map(function (s, i) { return arr[i] || s; }); };
var tokenParts = function (token) { return ensureThreeParts(splitParts(token)); };
var Jwt = (function () {
    function Jwt(token) {
        var parts = tokenParts(token);
        this._header = parts[0] ? JSON.parse(atob(parts[0])) : { alg: '' };
        this._payload = parts[1] ? JSON.parse(atob(parts[1])) : { email: '', user_id: '' };
    }
    Object.defineProperty(Jwt.prototype, "alg", {
        get: function () {
            return this._header.alg;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Jwt.prototype, "user", {
        get: function () {
            return this._payload.email;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Jwt.prototype, "uuid", {
        get: function () {
            return this._payload.user_id;
        },
        enumerable: true,
        configurable: true
    });
    return Jwt;
}());
exports.Jwt = Jwt;
//# sourceMappingURL=jwt.js.map