export declare type SetOrder = 'asc' | 'desc';
export interface IDictionary<T> {
    [index: string]: T;
}
export declare const matcher: <T>(fieldName: string, value: any) => (d: T) => boolean;
export declare const sortableValue: (d: string | number | {}) => string | number;
export declare abstract class BaseStorage<T> {
    protected entities: IDictionary<T> | T[];
    protected filtered: T[];
    protected ordered: T[];
    protected filterString: string;
    protected filterField: string;
    protected _sortByField: string;
    protected _sortByOrder: SetOrder;
    protected abstract getValue(t: T, prop: string): any;
    protected abstract matchType(matchFunction: (d: T) => boolean, t: T): boolean;
    abstract append(entity: T): void;
    abstract bulkAppend(list: T[]): void;
    protected abstract filterAndSort(): void;
    readonly sortByField: string;
    readonly sortByOrder: SetOrder;
    readonly filter: string;
    readonly filterByField: string;
    readonly filteredCount: number;
    protected sort(): void;
    sortBy(field: string, order: SetOrder): void;
    filterBy(filter?: string, field?: string): void;
    range(start?: number, end?: number): T[];
    indexOf(fieldName: string, value: any): number;
}
