"use strict";
var _ = require('lodash');
// TODO: make this more legible
exports.matcher = function (fieldName, value) {
    return function (d) {
        var v = _.get(d, fieldName);
        return v ? v === value : false;
    };
};
exports.sortableValue = function (d) {
    if (_.isString(d)) {
        return d.toLowerCase();
    }
    if (_.isNumber(d)) {
        return d;
    }
    return d.toString().toLowerCase();
};
var BaseStorage = (function () {
    function BaseStorage() {
    }
    Object.defineProperty(BaseStorage.prototype, "sortByField", {
        get: function () {
            return this._sortByField;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseStorage.prototype, "sortByOrder", {
        get: function () {
            return this._sortByOrder || 'asc';
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseStorage.prototype, "filter", {
        get: function () {
            return this.filterString || '';
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseStorage.prototype, "filterByField", {
        get: function () {
            return this.filterField || '*';
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseStorage.prototype, "filteredCount", {
        get: function () {
            return this.filtered.length;
        },
        enumerable: true,
        configurable: true
    });
    BaseStorage.prototype.sort = function () {
        var _this = this;
        if (this.sortByField) {
            this.ordered = _.orderBy(this.filtered, function (p) { return exports.sortableValue(_this.getValue(p, _this.sortByField)); }, this.sortByOrder);
        }
        else {
            this.ordered = this.filtered;
        }
    };
    ;
    BaseStorage.prototype.sortBy = function (field, order) {
        if (this._sortByField === field && this._sortByOrder === order) {
            return;
        }
        this._sortByField = field;
        this._sortByOrder = order;
        this.sort();
    };
    ;
    BaseStorage.prototype.filterBy = function (filter, field) {
        if (this.filterString === filter && this.filterField === field) {
            return;
        }
        this.filterString = filter;
        this.filterField = field;
        this.filterAndSort();
    };
    ;
    BaseStorage.prototype.range = function (start, end) {
        if (start === void 0) { start = 0; }
        if (end === void 0) { end = 25; }
        return this.ordered.slice(start, end);
    };
    ;
    BaseStorage.prototype.indexOf = function (fieldName, value) {
        var _this = this;
        var m = exports.matcher(fieldName, value);
        return _.findIndex(this.ordered, function (t) { return _this.matchType(m, t); });
    };
    ;
    return BaseStorage;
}());
exports.BaseStorage = BaseStorage;
//# sourceMappingURL=base-storage.js.map