import { BaseStorage, IDictionary } from './base-storage';
export declare const createDictionaryFilter: <T>(pattern?: string, field?: string) => (d: T) => boolean;
export declare abstract class Storage<T> extends BaseStorage<T> {
    protected entities: IDictionary<T>;
    constructor();
    protected abstract getId(t: T): string;
    readonly count: number;
    protected filterAndSort(): void;
    remove(identifier: string): void;
    append(entity: T): void;
    bulkAppend(list: T[]): void;
}
