"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var _ = require('lodash');
var base_storage_1 = require('./base-storage');
// `List<T>` tells the lodash method `_.some()` which kind of collection to expect, in this case an array, which is
// described by the lodash interface `List`
exports.createValuesFilter = function (pattern, field) {
    var fieldName = field === '*' ? undefined : field;
    if (!pattern && !fieldName) {
        return function (d) { return true; };
    }
    if (!fieldName) {
        return function (d) {
            return _.some(d, function (prop) {
                return _.isUndefined(prop) ? false : prop.toString().toLowerCase().indexOf(pattern.toLocaleLowerCase()) >= 0;
            });
        };
    }
    return function (d) {
        var v = _.get(d, fieldName);
        return v ? v.toString().toLowerCase().indexOf(pattern.toLocaleLowerCase()) >= 0 : false;
    };
};
var ValueStorage = (function (_super) {
    __extends(ValueStorage, _super);
    function ValueStorage() {
        _super.call(this);
        this.entities = [];
        this.filtered = [];
        this.ordered = [];
        this._sortByOrder = 'asc';
    }
    Object.defineProperty(ValueStorage.prototype, "count", {
        get: function () {
            return this.entities.length;
        },
        enumerable: true,
        configurable: true
    });
    ValueStorage.prototype.filterAndSort = function () {
        var _this = this;
        var filter = exports.createValuesFilter(this.filter, this.filterByField);
        this.filtered = this.filter ? _.filter(this.entities, function (p) { return _this.matchType(filter, p); }) : this.entities;
        this.sort();
    };
    ;
    ValueStorage.prototype.append = function (entity) {
        this.entities.push(entity);
        this.filterAndSort();
    };
    ;
    ValueStorage.prototype.bulkAppend = function (list) {
        var _this = this;
        list.forEach(function (e) {
            _this.entities.push(e);
        });
        this.filterAndSort();
    };
    ;
    return ValueStorage;
}(base_storage_1.BaseStorage));
exports.ValueStorage = ValueStorage;
//# sourceMappingURL=value-storage.js.map