export interface IGTMContext {
    'user.uuid'?: string;
    'user.email'?: string;
    'user.internal'?: string;
    'organization.name'?: string;
    'organization.type'?: string;
    'webapp.name': string;
    'webapp.version'?: string;
    'event'?: string;
}
export declare class WindowRef {
    location(path: string): void;
    getLocal(key: string): any;
    setLocal(key: string, value: any): any;
    cookies(): string;
    gtmContext(context: IGTMContext): void;
}
export declare class WindowMock implements WindowRef {
    locationPath: string;
    cookieString: string;
    gtmContexts: IGTMContext[];
    local: any;
    constructor();
    location(path: string): void;
    getLocal(key: string): any;
    setLocal(key: string, value: any): void;
    gtmContext(context: IGTMContext): void;
    cookies(): string;
}
